package org.test;

import com.vaadin.annotations.VaadinServletConfiguration;
import com.vaadin.annotations.Widgetset;
import com.vaadin.server.VaadinRequest;
import com.vaadin.server.VaadinServlet;
import com.vaadin.ui.Button;
import com.vaadin.ui.ComboBox;
import com.vaadin.ui.HorizontalLayout;
import com.vaadin.ui.UI;

import javax.servlet.annotation.WebServlet;

/**
 * This UI is the application entry point. A UI may either represent a browser window 
 * (or tab) or some part of a html page where a Vaadin application is embedded.
 * <p>
 * The UI is initialized using {@link #init(VaadinRequest)}. This method is intended to be 
 * overridden to add component to the user interface and initialize non-component functionality.
 */
@Widgetset("ws6fe03653c44c1014a0e011e9c716bb66")
public class MyUI extends UI {

    private final ComboBox<String> combo = new ComboBox<>();
    @Override
    protected void init(VaadinRequest vaadinRequest) {
        final HorizontalLayout hl = new HorizontalLayout();
        final Button resetStuff = new Button("Reset", e -> resetCombo());
        resetCombo();
        hl.setWidth("100%");
        hl.addComponents(combo, resetStuff);
        setContent(hl);
    }

    private void resetCombo() {

        // this works flawlessly - the combo box selection is cleared properly
/*
        combo.setValue(null);
        combo.setItems("" + System.currentTimeMillis());
*/

        // when the value is set *after* the new items are set, the value is not cleared in the ComboBox
        combo.setItems("" + System.currentTimeMillis());
        combo.setValue(null);
    }

    @WebServlet(urlPatterns = "/*", name = "MyUIServlet", asyncSupported = true)
    @VaadinServletConfiguration(ui = MyUI.class, productionMode = false)
    public static class MyUIServlet extends VaadinServlet {
    }
}
